bump = require 'bump'
range = 4
death_time = 1
world = bump.newWorld(range*4)
shipclass = require('shipclass')
bg = love.graphics.newImage("bg.jpg")
ships = {}

use_bump = true

function love.draw()
  love.graphics.draw(bg)
  for si,sv in pairs(ships) do
    sv:draw()
  end
  local ctime = love.timer.getTime( )
  love.graphics.print(
    "Using Bump: "..( use_bump and "Yes" or "No" ).."\n"..
    "Collision Checks: "..collision_count.."\n"..
    "Collision Checks per second: "..(collision_count/(ctime-time)).."\n"..
    "Ships: "..#ships.."\n"..
    "FPS: "..love.timer.getFPS())
end

make = 0
collision_count = 0
time = love.timer.getTime( )

function love.update(dt)
  make = make + dt
  if make >= 0.0001 then
    make = 0
    love.mousepressed(
      -32 + math.random(0,1)*(love.graphics.getWidth()+64),
      math.random(-32,love.graphics.getHeight()+64),
      "l",1)
    love.mousepressed(
      math.random(-32,love.graphics.getWidth()+64),
      -32 + math.random(0,1)*(love.graphics.getHeight()+64),
      "l",2)

  end
  for si,sv in pairs(ships) do
    collision_count = collision_count + sv:update(dt)
    if sv:getDead() and sv:getDead() <= 0 then
      world:remove(sv)
      table.remove(ships,si)
    end
  end
end

function love.mousepressed(x,y,key,team)
  if key == "l" then
    local ship = shipclass.new({x=x,y=y,range=range,team=team or 1})
    table.insert(ships,ship)
    world:add(ship,
      ship:getX()-ship:getRange(),
      ship:getY()-ship:getRange(),
      ship:getRange()*2,
      ship:getRange()*2)
  elseif key == "r" then
    for si,sv in pairs(ships) do
      world:remove(sv)
    end
    ships = {}
    collision_count = 0
    time = love.timer.getTime( )
    use_bump = not use_bump
  end
end

function love.keypressed(key)
  if key == "`" then
    debug = not debug
  end
end
